var webpack = require('webpack');
var path = require('path');
var _ = require('underscore');
var gulp = require('gulp');
var gutil = require('gulp-util');
var src = process.cwd() + '/src';
var assets = process.cwd() + '/build';
var webpackConf = require(process.cwd() + '/webpack.config');

var defaultWebpackConfig = require('../configs/default.webpack.configs.js' )({
  debug:false
});
var webpackDevConf = require(path.join(process.cwd(), './webpack.config'));

var webpackConfigs = _.extend(defaultWebpackConfig,webpackDevConf);


function taskWebpack(done){
  webpack(webpackConfigs, function(err, stats) {
      if(err) throw new gutil.PluginError('webpack', err);
      gutil.log('[webpack]', stats.toString({colors: true}));
      done();
  });
}


function build(){
  var replace = require('gulp-replace');
  var htmlmin = require('gulp-htmlmin');

  return gulp
      .src(assets + '/*.html')
      .pipe(replace(/<script(.+)?data-debug([^>]+)?><\/script>/g, ''))
      // @see https://github.com/kangax/html-minifier
      .pipe(htmlmin({
          collapseWhitespace: true,
          removeComments: true
      }))
      .pipe(gulp.dest(assets));
}




module.exports = function(program){

  //编译
  taskWebpack(build);
}